<template>
  <div class="ob-func-panel">
    <div class="ob-func-panel__controls">
      <div class="ob-func-panel__controls-side">
        <div
          v-if="showAddButton"
          class="ob-func-panel__control"
        >
          <div
            class="ob-func-panel__control-row"
            :data-qa="dataQa"
            @click="addHandler"
          >
            <i class="icon plus" />
            <span>{{ addButtonText }}</span>
          </div>
        </div>

        <add-buttons
          v-if="addButtons && addButtons.length"
          :buttons="addButtons"
          :options="addButtonsOptions"
          @add="addHandler"
        />

        <!--<FilterButton v-if="showFilter" />-->
        <div
          v-if="showGroup"
          class="ob-func-panel__control"
        >
          <div
            class="ob-func-panel__control-row"
            :data-qa="dataQa"
            @click="$emit('group',$event)"
          >
            <i class="icon group" />
          </div>
        </div>
        <div
          v-if="showSort"
          class="ob-func-panel__control"
        >
          <div
            class="ob-func-panel__control-row"
            :data-qa="dataQa"
            @click="$emit('sort',$event)"
          >
            <i class="icon sort" />
          </div>
        </div>
        <div
          v-if="showRefresh"
          class="ob-func-panel__control-row"
        >
          <div
            class="ob-func-panel__control"
            :data-qa="dataQa"
            @click="refreshHandler"
          >
            <i class="icon refresh" />
          </div>
        </div>
        <div
          v-if="showEdit"
          class="ob-func-panel__control-row"
        >
          <div
            class="ob-func-panel__control"
            :data-qa="dataQa"
            @click="editHandler"
          >
            <i class="icon edit" />
          </div>
        </div>
        <more-button
          v-if="showColumnFilter && filteredColumns.length"
          :columns="filteredColumns"
          :show-hidden-length="showHiddenLength"
          :data-qa="dataQa"
          @toggle-column-visibility="onToggleColumnVisibility"
        />
        <template v-if="$scopedSlots.buttons">
          <div class="ob-func-panel__control">
            <div class="ob-func-panel__control-row ob-func-panel__control-row_extra-panel">
              <slot name="buttons" />
            </div>
          </div>
        </template>
        <div
          v-if="filterButtons"
          class="ob-func-panel__control ob-func-panel__filter-buttons"
        >
          <div class="ob-func-panel__control-row">
            <div
              v-for="(item, index) in filterButtons"
              :key="`filter-button-${index}`"
              class="ob-func-panel__filter-buttons__panel-item"
              :class="[
                item._isActive && '--active',
                index == 0 && '--left',
                (index == filterButtons.length - 1) && '--right'
              ]"
            >
              <button
                class="ob-func-panel__filter-buttons__panel-button"
                :data-qa="dataQa"
                @click="onClickFilterButton(item)"
              >
                <span
                  v-if="item.html"
                  v-html="item.html"
                />
                <span v-else>
                  {{ item.title }}
                </span>
              </button>
            </div>
          </div>
        </div>
      </div>
      <slot name="controls" />
      <div class="ob-func-panel__controls-side">
        <template v-if="$scopedSlots.extraFuncToPanel">
          <div class="ob-func-panel__control">
            <div class="ob-func-panel__control-row ob-func-panel__control-row_extra-panel">
              <slot name="extraFuncToPanel" />
            </div>
          </div>
        </template>
        <div
          v-if="showSearch"
          class="ob-func-panel__control"
        >
          <div class="ob-func-panel__control-row ob-func-panel__control-row_search">
            <transition name="fade">
              <div
                v-if="isSearchOpen"
                class="ob-func-panel__control-row_search-wrapper"
              >
                <input
                  ref="input-search"
                  v-model="query"
                  v-debounce:300ms="handlerSearch"
                  :data-qa="dataQa"
                  class="ob-func-panel__control-input"
                >
                <transition name="fade">
                  <i
                    v-if="query"
                    ref="clear-button"
                    class="icon close"
                    :data-qa="dataQa"
                    @click="cleare"
                  />
                </transition>
              </div>
            </transition>
            <i
              ref="search-button"
              class="icon search"
              :data-qa="dataQa"
              @click="toggleSearch"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Vue from 'vue'
import MoreButton from './more-button'
import AddButtons from './add-buttons'
import vueDebounce from 'vue-debounce'

Vue.use(vueDebounce)
export default {
  components: {
    MoreButton,
    AddButtons
  },
  props: {
    columns: {
      type: Array,
      required: true
    },
    showColumnFilter: {
      type: Boolean,
      default: true
    },
    showSearch: {
      type: Boolean,
      default: true
    },
    showFilter: {
      type: Boolean,
      default: true
    },
    showGroup: {
      type: Boolean,
      default: true
    },
    showSort: {
      type: Boolean,
      default: true
    },
    showEdit: {
      type: Boolean,
      default: false
    },
    showRefresh: {
      type: Boolean,
      default: false
    },
    showAddButton: {
      type: Boolean,
      default: false
    },
    addButtonText: {
      type: String,
      default: 'Добавить'
    },
    addButtons: {
      type: Array
    },
    addButtonsOptions: {
      type: Object
    },
    filterButtons: {
      type: Array
    },
    showHiddenLength: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      openColumnFilter: false,
      isSearchOpen: false,
      isFilterOpen: false,
      openFilter: false,
      query: ''
    }
  },
  computed: {
    filteredColumns: ({ columns }) => columns.filter(column => !column.isToggleDisabled)
  },
  watch: {
    filterButtons: {
      handler (buttons) {
        if (!buttons?.length) {
          return
        }

        if (buttons.every(button => !button._isActive)) {
          // If there is no selected button - choosing the first one
          this.$set(buttons[0], '_isActive', true)
        }
      },
      immediate: true
    }
  },
  methods: {
    onClickFilterButton (button) {
      const currentSelectedButton = this.filterButtons.find(button => button._isActive)

      if (button === currentSelectedButton) {
        return
      }

      if (currentSelectedButton) {
        this.$set(currentSelectedButton, '_isActive', false)
      }

      this.$set(button, '_isActive', true)

      this.$emit('on-change-filter-button', button)
    },
    toggleSearch () {
      this.isSearchOpen = !this.isSearchOpen
      this.$nextTick(() => {
        if (this.isSearchOpen) {
          this.$refs['input-search'] && this.$refs['input-search'].focus()
        }
      })
    },
    closeFilter () {
      this.isSearchOpen = false
    },
    addHandler (it) {
      this.$emit('add', it)
    },
    editHandler () {
      this.$emit('onEdit')
    },
    refreshHandler () {
      this.$emit('onRefresh')
    },
    handlerSearch () {
      let query = this.query.trim()
      this.$emit('search', query)
    },

    onToggleColumnVisibility (column) {
      this.$emit('toggle-column-visibility', column)
    },
    cleare () {
      this.query = ''
      this.$emit('search', '')
    }
  }
}
</script>

<style lang="scss" scoped>
  .ob-func-panel {
    &::v-deep {
      .icon::before {
        color: $color-grey-span;
      }
      .icon.inherit::before {
        color: inherit;
      }
    }
  }
</style>

<style lang="scss">
.ob-func-panel {
  width: 100%;
  height: 60px;
  background: $background-white;
  &__filter-buttons {
    & .ob-func-panel__control-row{
      span {
        margin: 0px;
      }
      &:active:hover {
        opacity: 1;
      }
    }
    &-container {
      width: 100%;
    }

    &__panel {
      position: relative;
      display: flex;
      justify-content: flex-start;
      align-items: center;

      &-item {
        position: relative;
        transition: color .3s ease-in-out;
        box-shadow: inset 0px 0px 0px 1px $obFuncPanel-filter_buttons_panel_item_box-shadow;
        &.--active {
                background-color: $blue-blue-hoarfrost;
                box-shadow: inset 0px 4px 4px rgba($color-blue-navy-blue, 0.3);
        }
        &.--left {
          border-radius: 3px 0px 0px 3px;
        }
        &.--right {
          border-radius: 0px 3px 3px 0px;
        }
      }

      &-button {
        &:active:hover {
          opacity: 1;
        }
        height: 30px;
        display: flex;
        align-items: center;
        justify-content: center;
        padding: 0 12px;
        white-space: nowrap;
        border: none;
        text-align: center;
        outline: none;
        cursor: pointer;
        background: none;
        font-style: normal;
        font-weight: normal;
        font-size: 14px;
        line-height: 16px;
        letter-spacing: 0.2px;
        color: $color-blue-navy-blue;
      }
    }
  }
  &__controls {
    display: flex;
    justify-content: space-between;
    width: 100%;
    height: 100%;
    padding: 0 20px 0 10px;

    &-side {
      display: flex;
    }
  }
  &__control {
    position: relative;
    display: flex;
    flex-direction: column;
    justify-content: center;
    height: 100%;
    cursor: pointer;
    &-input {
      appearance: none;
      background-color: $background-white;
      border-radius: 4px;
      border: 1px solid $obFuncPanel-control_input_border;
      box-sizing: border-box;
      color: $obFuncPanel-control_input_color;
      display: inline-block;
      font-size: inherit;
      height: 40px;
      line-height: 40px;
      outline: 0;
      padding: 0 15px;
      transition: border-color 0.2s cubic-bezier(0.645, 0.045, 0.355, 1);
      width: 100%;
    }

    &-row {
      position: relative;
      display: flex;
      justify-content: flex-end;
      align-items: center;
      height: 100%;
      font-size: 16px;
      line-height: 20px;
      background: $background-white;
      padding: 0 11px;

      &_active {
        box-shadow: 0px 4px 16px rgba($color-text-base, 0.24), 0px -1px 6px rgba($color-text-base, 0.08);
        &::after {
          content: '';
          display: block;
          position: absolute;
          z-index: 10;
          left: 0;
          width: 100%;
          height: 18px;
          background-color: $background-white;
          transition: none;
          bottom: -8px;
        }
      }
      span {
        margin-left: 8px;
      }
      i {
        font-size: 20px;
      }
      .icon.more {
        color: $gray-window;
      }
      .icon.more.painted {
        color: $color-blue-navy-blue;
        &::before {
          color: $color-blue-navy-blue;
        }
      }
      .icon.plus {
        font-size: 24px;
      }
      .icon.sort {
        font-size: 24px;
      }
      &:active:hover {
        opacity: 0.5;
      }
      &_extra-panel:active:hover,
      &_search:active:hover {
        opacity: 1;
      }
      &_search {
        &-wrapper {
          position: relative;
          margin-right: 22px;
          input {
            padding-right: 30px;
          }
          i {
            position: absolute;
            top: 14px;
            right: 14px;
            font-size: 12px;
          }
        }
      }
    }

    &-dropdown {
      background: $background-white;
      position: absolute;
      display: flex;
      flex-direction: column;
      padding: 20px;
      top: 60px;
      left: 0;
      min-width: 300px;
      box-shadow: 0px 4px 16px rgba($color-text-base, 0.24), 0px -1px 6px rgba($color-text-base, 0.08);
      z-index: 1;
      &-item {
        display: flex;
        justify-content: space-between;
        width: 100%;
        height: 36px;
        align-items: center;

        span:nth-child(2) {
          margin-top: -6px;
        }
      }
    }
  }
}
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.3s;
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
}
  .ob-func-panel__control-dropdown{
    z-index: 101;
  }
</style>
